






                                    JUNOFILE

                            An Patch Editor/Librarian
                       for the Roland Juno-106 Synthesiser

                                   User Manual

                               V1.1 Draft Release

                                 By Leigh Smith

                           leigh@psychokiller.dialix.oz.au
                            Perth, Western Australia
                     +61-9-382-3071 (most sane local times)

                                    29/10/92
                         JunoFile User Manual V1.1



        REQUIREMENTS

        Junofile  is a program for displaying and saving Roland  Juno-106 
        Synthesiser  patches  to  disk  file.  At  present,  this  program 
        requires:

        1.  An  IBM  PC [1234]86 machine. The program does  not  seem  to 
        require  a hard disk, fast processor or much RAM, but of  course, 
        the faster the hardware, the slicker it seems (Ha ha).

        2. A Roland MPU-401 MIDI interface operating on interrupts IRQ  2 
        through  to  7.  The interrupt is  determined  automatically,  no 
        configuration by the user is required. At present, the MPU-401 is 
        assumed to be configured for I/O address base 330h. Contact me if 
        this is not ok for you.

        3.  A  Colour CGA or any graphics adapter which can  display  CGA 
        text  mode. Only text graphics are used in this program  (so  sue 
        me!). A colour monitor is recommended for best results.

        4.  A Juno-106 Synth + cabling, with the MIDI Mode switch on  the 
        back panel set at position III. This must be so to cause the Juno 
        to send out System Exclusive messages.

        Installation  consists  of extracting the files out of  the  .ZIP 
        package  and  placing the junofile.exe program into  a  directory 
        which is listed in the PATH environment variable.  Alternatively, 
        this file can be placed in the same directory as the data files.

        OVERVIEW

        Junofile communicates to and from the synthesiser via the  Roland 
        MIDI System Exclusive protocol to display a representation of the 
        Juno's  front  panel on the PC screen. Selecting a patch  on  the 
        Juno  causes  the  new  patch to be transmitted  to  the  PC  and 
        displayed on the front panel. Moving the synthesisers sliders  or 
        switches   (other   than   the   portamento   switch   or   pitch 
        bend/modulation sliders) will be reflected immediately on-screen. 
        The  purpose  of  Junofile  is to show  the  settings  that  form 
        existing  patches,  and  allow  a  easier  visual  'tweaking'  of 
        parameters. Patches which are uploaded to the PC are then able to 
        be  commented with a description of the patch and  an  instrument 
        name or sound category. These names and descriptions, along  with 
        the patch can be saved to a DOS file and then can be retrieved by 
        searching  on instrument name, or using the patch itself  as  the 
        key. It is therefore easy to dump all sounds from the synthesiser 
        to  the disk file ensuring there are no duplicated sounds and  to 
        later  retrieve and audition related groups of  patches.  Minimal 
        (not  minimalist  :-) ) sequence record and  play  functions  are 
        provided  to  allow sounds to be auditioned in the context  of  a 
        performed passage. 





                                   2
                         JunoFile User Manual V1.1


        OPERATING PHILOSOPHY

        Typically  and most efficiently, the user will work at the  front 
        panel  of the Juno while selecting programs and editting  values. 
        This  is  different from most other synth editors  which  usually 
        concentrate  the  work  of the user at the  PC.  The  work  ethic 
        adopted here is enforced by the Juno synthesiser being unable  to 
        be  commanded  to  upload it's patches,  they  must  be  manually 
        selected  by  pressing the Juno's patch  select  buttons.  Saving 
        patches  downloaded from the PC to the Juno's patch  memory  must 
        also be performed manually. Selecting and auditioning sounds  (no 
        editting at present) can be performed at the PC alone.

        OPERATION

        Following  the copyright message, the main display is  presented. 
        At  the top of the screen displays the MIDI channel  (1-16),  the 
        current  state of the MPU-401 Thru (On/Off), the current note  to 
        audition  a patch with and the current selected patch  (--,  A11-
        B88).  When  a previously recalled patch is altered by  moving  a 
        slider,  the message "(Modified)" will be displayed next  to  the 
        patch.

        The  middle of the screen is taken up with a text  representation 
        of  the  Juno's  front panel. Selecting a patch  button  (or  the 
        manual button) on the Juno will transmit the patch parameters  to 
        the  PC.  These will be represented as slider  positions  on  the 
        screen.

        Below the front panel representation lies two fields for entering 
        an  instrument name and a more verbose description of the  sound. 
        Immediately  below  the Description field is the line  where  any 
        status messages are displayed. These messages will remain until a 
        new  message  appears or the screen is refreshed.  The  last  two 
        lines  of the screen list various commands which are selected  by 
        pressing  the  highlighted key. The  instrument  and  description 
        fields, together with the other available commands are  explained 
        below: (Note keypresses are case-insensitive)

        'A':
            Audition the patch currently selected in the Juno, sending  a 
            MIDI note on to sound the note until A is pressed again.

        'B':
            Bulk  Save,  saves all patches sent from the Juno  (that  is, 
            those  buttons pressed by the user) that are not  already  on 
            file.  This  saving will continue until a key on  the  PC  is 
            pressed. Each patch will be saved to file with the Instrument 
            'Bulk  Save' and the Patch number and time and date  for  the 
            description. This is intended to be used to quickly dump  all 
            patches  from the Juno to the PC. The easiest way is  to  set 
            bulk  save,  then holding down each bank  button,  the  patch 
            buttons  are 'swiped' across with a finger, sending  each  to 
            the  Juno.  Manual  is  not  saved  when  bulk  saving.   The 
            instrument names and descriptions can be editted later  after 


                                   3
                         JunoFile User Manual V1.1


            auditioning.

        'C':
            Change MIDI channel, type the new MIDI channel number,  which 
            will be set if the number is legitimate (1-16). This  channel 
            will  be used when sending the auditioning note to  the  Juno 
            and  when  any patch is to be sent. It will  not  effect  the 
            recorded  sequence. When a patch is received from  the  Juno, 
            it's MIDI channel will become the new channel value.

        'D':
            Set  the Description field. An alphanumeric descriptive  name 
            may  be  entered into the field. While entering  this  value, 
            limited editting is possible with the Left/Right arrows, Home 
            and End keys to position the cursor, the Backspace and Delete 
            keys to remove characters to the left and right of the cursor 
            and  the  Insert key to insert characters as they  are  typed 
            instead of the default of overtyping characters in the field.

        'I':
            Set  the  Instrument  field. This offers  the  same  editting 
            ability  as  the Description field above.  After  entry,  the 
            field  will  have  it's  first  letter  capitalised  and  the 
            remainder set to lower case.

        'H':
            Prints a help window. Press another key to return to the main 
            display.

        'J':
            Jumble the patch - using good ol' rand() white noise. More of 
            a  gimick than anything really useful, but if it gets a  good 
            patch once in a while, what the heck.

        'N':
            Change the note to Audition with, this simply increments  the 
            note by a semitone, wrapping around at C7 to C0.

        'P':
            Play  the  current sequence. Plays  the  previously  recorded 
            sequence  back, including any delay before the first note  is 
            struck.  The  sequence  is played back  with  the  same  MIDI 
            channel as was recorded, so if the Juno's channel is  changed 
            the  sequence  will not be heard. Different  patches  can  be 
            tested  to  find  the  most appropriate  patch  for  a  given 
            sequence.

        'R':
            Record  a sequence to DOS file. Any keys or controllers  will 
            be saved to file for later playback.

        ESC, 'Q':
            Quit the program.

        'S':


                                   4
                         JunoFile User Manual V1.1


            Save  patch  to  disk only if an  instrument  name  has  been 
            assigned. Use this function to update changed instrument  and 
            description fields to DOS file also.

        'E':
            Erase the current patch displayed from the file. This is  not 
            reversible, so be careful.

        'L':
            List patches on file, sorting by instrument name and  showing 
            only this field and the description, one patch per line.  The 
            patches  will be displayed in a window which can be  scrolled 
            upwards  and downwards using the Up/Down/PageUp and  PageDown 
            keys.  As each patch is scrolled, it is sent to the Juno,  so 
            that each may be auditioned with the 'A' key.

        'F':
            Find  Instrument  in file causes all patches  with  the  same 
            instrument  field to be listed in the same manner as  listing 
            patches,  which  can also be scrolled through,  sending  each 
            patch to the Juno.

        'T':
            Toggle the Thru Mode of the MPU-401 between On and Off.  This 
            is  typically required if you wish to control  another  sound 
            module with the Juno.

        NOTES

        To save a patch, ensure the Juno is correctly connected, and that 
        pressing a patch changes the PC's display. Select 'I' to set  the 
        instrument  field,  using  a generalising category  to  save  the 
        patch,  say  Strings  or  Percussion.  Select  'D'  to  set   the 
        descriptive  field, say 'Deep and Warm, used in  Eleanor  Rigby'. 
        Then press 'S' to save the patch to file. Selecting that patch on 
        the  Juno  again  will cause the file to be  searched,  and  will 
        redisplay the Instrument and Description Fields when it is found. 
        Changing  any of the Sliders or Switches will indicate the  Patch 
        has  been modified. Saving again will not overwrite the  existing 
        patch as the modified patch is considered a new patch.

        All  saving and retrieving to DOS file are performed to the  file 
        JunoPtch.idx and JunoPtch.dat (C-ISAM files for the curious). If 
        no  such  files  exist in the working  directory,  they  will  be 
        created.  The  sequence  file created if  'R'  for  recording  is 
        pressed is JunoPtch.seq. At present, this file is of MPU sequence 
        format codes.

        While  it would seem logical to allow changing the  patch  number 
        thereby causing the Juno to select a new patch and displaying  it 
        on  the programs front panel display, the MIDI implementation  of 
        the  Juno prevents this. The patch buttons on the synth  must  be 
        pressed.




                                   5
                         JunoFile User Manual V1.1


        TO DO

        As  this program has been a very casual effort on my part,  being 
        on and off over about four years, there are several things to  do 
        which,  if  there is a call by others, I will  fufill.  The  list 
        below  is a summary of the work which is planned. Please  contact 
        me if there are improvements or bugs (gasp!) which you would like 
        attended to. To provide some sanity to versions, I don't  release 
        source  code  unless  someone needs it, I  would  prefer  if  you 
        contact  me  so that I'll do the mods and incorporate it  in  the 
        next release. If you REALLY want the code, contact me above.

        Future Improvements:
        --------------------
           If  no  MPU-401  present,  Junofile  will  still  allow   file    
           operations, listing/deleting/displaying etc.

           Different  database files will be able to be specified on  the    
           command  line, keeping a sequence for each one. This  filename    
           will be displayed for the user.

           The  sequence file which is played back will be a  standard  0 
           MIDI file.

           Editting  each parameter, VCO etc, sending new values  to  the 
           Juno from the PC keyboard.

           Allowing for Mono screen operation, and for larger than  80x25 
           screen modes.

           Enable the use of a mouse.

           There will be a method of saving the patch bank/number of each 
           patch on the PC, so if all the patches were lost on the synth, 
           the   synth  could  be  completely  returned  to   the   patch 
           arrangements last saved. Additionally, patches will be able to 
           be rearranged on the PC before being dumped onto the Juno,  so 
           common patches or song related patches can be grouped.

           I'm planning a complete rewrite to run under NeXTStep, I haven't
           decided the future of the DOS version.

















                                   6
